﻿#include <iostream>
#include <string.h>
#include <deque>
#include <vector>
using namespace std;
#define _CRT_NO_SECURE_WARNINGS
typedef long long ll;
typedef pair<int, ll> pl;

vector <pl> tree;// min, sum
vector <int> d;

void build()
{
	int t = d.size();
	for (int i = 2 * t - 1; i >= 0; i--)
	{
		if (i >= t)
		{
			tree[i] = make_pair(d[i - t], d[i - t]);
		}
		else
		{
			tree[i] = make_pair(min(tree[i * 2].first, tree[i * 2 + 1].first), tree[i * 2].second + tree[i * 2 + 1].second);
		}
	}
}

pl return_min_sum(int l, int r, int ll, int rr, int i)
{
	if (l == ll && r == rr)
	{
		return tree[i];
	}
	int lr = (ll + rr) / 2;
	if (l <= lr - 1 && lr - 1 < r)
	{
		pl a = return_min_sum(l, lr - 1, ll, lr - 1, 2 * i);
		pl b = return_min_sum(lr, r, lr, rr, 2 * i + 1);
		return make_pair(min(a.first, b.first), a.second + b.second);
	}
	else if (l <= lr-1 && r <=lr-1)
	{
		return return_min_sum(l, r, ll, lr - 1, 2 * i);
	}
	else if (lr <= l && lr <= r)
	{
		return return_min_sum(l, r, lr, rr, 2 * i + 1);
	}
}

int main()
{
	ll MAINSUM = 0;
	int n, k;
	//k = 3;
	cin >> n >> k;
	vector <int> a;
	a.resize(n);
	ll s = 0;
	int mina = 0;
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
		s += a[i];
		MAINSUM += a[i];
		if (a[i] < a[mina])
		{
			mina = i;
		}
	}
	if (k == 2)
	{
		if (a[0] < a[n - 1])
		{
			cout << s - a[0] - a[0];
		}
		else
		{
			cout << s - a[n - 1] - a[n - 1];
		}
	}
	else
	{
		for (int i = n - k + 1; i < n; i++)
		{
			d.push_back(a[i]);
		}
		for (int i = 0; i < k - 1; i++)
		{
			d.push_back(a[i]);
		}
		int t = 0;
		while (2 * (k - 1) > (1 << t))
		{
			t++;
		}
		d.resize(1 << t, 10e+9-1);
		tree.resize(2 * d.size());
		build();
		ll ans = 0;
		for (int j = 0; j < k; j++)
		{
			s = MAINSUM;
			pl f = return_min_sum(j + 1, j + k, 1, d.size() * 2 - 1, 1);
			s = s - f.second;
			ans = max(ans, s - f.first);
		}
		//cout << ans;
		s = 0;
		for (int i = 0; i < n - k + 1; i++)
		{
			s += a[i];
			ans = max(ans, s - a[i + 1]);
		}
		s = 0;
		for (int i = n - 1; i >= k - 1; i--)
		{
			s += a[i];
			ans = max(ans, s - a[i - 1]);
		}
		cout << ans;
	}
}